SystemOrganization addCategory: #'GT-Metaceller-Glamour'!

!GTMetacellerVersion methodsFor: '*gt-metaceller-glamour' stamp: 'DiegoLont 3/17/2014 11:40'!
asText
	self isRelease ifTrue: [ ^Text string: self versionNumber attribute: TextEmphasis bold ].
	self isBaseline ifTrue: [ ^Text string: self versionNumber attribute: TextColor red ].
	self isDevelopment ifTrue: [ ^Text string: self versionNumber attribute: TextColor blue ].
	^Text fromString: self versionNumber! !

!MetacelloPackageSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:11'!
labelAsText	
	^ self needsSaving
			ifTrue: [ Text string: self file attribute: TextColor blue] 
			ifFalse: [ Text fromString: self file ]! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 10:25'!
acceptCode: aText version: aVersion 
	aVersion methodClass compile: aText asString classified: aVersion methodCategory.
	self announce: GTConfigChanged! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:14'!
actionsForItem: anItem
	| retVal |
	retVal := OrderedCollection new.
 	retVal add: ((GLMGenericAction new) 
			action: [:list :version | self load: list selection fromVersion: version ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [:list | list selection inspect ];
			title: 'Inspect'
			yourself).
	(self isProject: anItem) ifTrue: [ retVal add: ((GLMGenericAction new) 
						action: [ :list | self fetchProject: list selection ];
						title: 'Load configuration'
						yourself) ].
	^retVal! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:19'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/10/2013 13:18'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:04'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metaceller'.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		row: [  :r | r
				column: #configs;
				column: #versions;
				column: #packages span: 2 ];
		row: #details.
	browser transmit
		to: #configs;
		andShow: [ :a | self configurationsIn: a ].
	browser transmit
		from: #configs;
		to: #versions;
		andShow: [ :a | self versionBrowserOn: a ].
	browser transmit
		from: #configs;
		to: #details;
		andShow: [ :a | self detailsForConfiguration: a ].
	browser transmit
		from: #versions;
		to: #details;
		andShow: [ :a | self detailsForVersion: a ].
	browser transmit
		from: #versions;
		to: #packages;
		andShow: [ :a | self packageBrowserOn: a ].
	browser transmit
		from: #packages;
		to: #details;
		andShow: [ :a | self detailsForPackage: a ].
	^ browser! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:09'!
childrenForItem: anItem
	anItem isString ifTrue: [ ^#() ].
	^anItem children! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/13/2013 10:08'!
configurationsIn: a
	^ a tree
		title: 'Configurations';
		format: [ :configuration | configuration shortName ];
		children: [ :configuration | configuration children ];
		updateOn: GTConfigLoaded from: self announcer;
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousRefresh on: $r entitled: 'Refresh' with: [ :pane | self announce: GTConfigLoaded ];
		selectionAct: [ :list | list selection browse ] entitled: 'Browse implementation';
		selectionAct: [ :list | list selection mainProject inspect ] entitled: 'Inspect'! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/13/2013 10:16'!
detailsForConfiguration: aBrowser
	(aBrowser respondsTo: #roassal) ifTrue: [ 
		aBrowser roassal
			title: 'Imports';
			painting: [:view :config | config viewVersionMapOn: view] ]
		ifFalse: [ 
			aBrowser text
				title: 'Imports';
				display: 'Please install roassal to see the imports' ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/10/2013 11:35'!
detailsForMethod: aBrowser
	aBrowser smalltalkCode
		smalltalkClass: [ :method | method methodClass ];
		display: [ :method | method asString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :method | self acceptCode: pane text method: method ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:00'!
detailsForPackage: aBrowser
	aBrowser text
		title: 'Package spec';
		display: [ :package | package asString ]! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 4/26/2013 16:21'!
detailsForVersion: aBrowser
	aBrowser smalltalkCode
		title: 'Method';
		smalltalkClass: [ :version | version methodClass ];
		display: [ :version | version methodString ];
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Accept' with: [ :pane :version | self acceptCode: pane text version: version ].
	(aBrowser respondsTo: #roassal) ifTrue: [ 
		aBrowser roassal
			title: 'Dependencies';
			painting: [ :view :version | self viewDependenciesOf: version on: view ] ]
		ifFalse: [ 
			aBrowser text
				title: 'Dependencies';
				text: 'Please install roassal to view dependencies' ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 10/8/2013 10:57'!
entity 
	^ ((Object subclasses select: [:each | self isMetacelloConfig: each]) sort: [:a :b | a name < b name])
		collect: [ :each | GTRefreshableMetacellerConfiguration on: each announcer: self announcer ]! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchProject: aProjectSpec
	" this seems more stable then the alternative:
			aProjectSpec resolveToLoadableSpec load.	
			that also fethces the versions we need.
	"
	aProjectSpec loadUsing: aProjectSpec loader gofer: nil.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
fetchVersion: aVersion
	aVersion fetch.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:15'!
groupsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion groupsAndLoosePackages! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/26/2013 15:52'!
helpText
	^'Metaceller is a tool for browsing and editing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Double clicking on an item spawns the configuration details.

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- bold = the stable version
- blue = the development version
- red  = the current bleeding edge
The tag shows the blessing of the configuration.

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = project
- bold = newer package in version than loaded in image
- underlined = package / project loaded in image
- italic = groups
- gray = older package in version than loaded in image
.'! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:08'!
isGroup: aSpec 
	^(aSpec isKindOf: MetacelloGroupSpec) or: [ aSpec isKindOf: GTMetacellerGroup ]! !

!GTMetaceller methodsFor: 'opening' stamp: 'DiegoLont 4/10/2013 14:05'!
isMetacelloConfig: anObject
	(anObject respondsTo: #isMetacelloConfig) ifTrue: [  
		(anObject className beginsWith: 'Metacello') ifFalse: [ ^anObject isMetacelloConfig ] ].
	^false! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/10/2013 10:55'!
isPackage: aSpec 
	^(self isProject: aSpec) not and: [ (self isGroup: aSpec) not ]! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 15:32'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ (aSpec isKindOf: MetacelloProjectSpec) ]! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 13:12'!
itemsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [  ^#() ].
	^aVersion packagesAndProjects! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
load: aSpec fromVersion: aVersion
	aVersion load: aSpec name.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 09:06'!
loadVersion: aVersion
	aVersion load.
	self announce: GTConfigLoaded! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:05'!
nameForItem: anItem
	^anItem labelAsText! !

!GTMetaceller methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:56'!
orderFor: anItemA and: anItemB 
	^anItemA label asLowercase < anItemB label asLowercase! !

!GTMetaceller methodsFor: 'building' stamp: 'VincentBlondeau 2/14/2014 17:03'!
packageBrowserOn: aBrowser
	aBrowser tree
		title: 'Packages (load order)';
		display: [ :version | (self itemsForVersion: version) reject: [ :each | each isGroup ] ];
		children: [ :item | self childrenForItem: item ];
		format: [ :item | self nameForItem: item ];
		tags: [ :spec :version | self tagsOfSpec: spec in: version ];
		dynamicActionsOnSelection: [ :list | self actionsForItem: list selection ];
		updateOn: GTConfigChanged from: self announcer.
	aBrowser tree
		title: 'Groups';
		children: [ :item | self childrenForItem: item ];
		display: [ :version | self groupsForVersion: version ];
		updateOn: GTConfigChanged from: self announcer;
		format: [ :item | self nameForItem: item ].
	aBrowser tree
		title: 'Packages (alphabetical)';
		display: [ :version | (self itemsForVersion: version) asSortedCollection: [ :a :b | self orderFor: a and: b ] ];
		children: [ :item | (self childrenForItem: item) asSortedCollection: [ :a :b | self orderFor: a and: b ] ];
		format: [ :item | self nameForItem: item ];
		tags: [ :spec :version | self tagsOfSpec: spec in: version ];
		dynamicActionsOnSelection: [ :list | self actionsForItem: list selection ];
		updateOn: GTConfigChanged from: self announcer! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:36'!
tagsOfSpec: aSpec in: aVersion
	^aVersion tagsOf: aSpec! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 11:38'!
tagsOfVersion: aVersion
	^aVersion tags! !

!GTMetaceller methodsFor: 'private' stamp: 'DiegoLont 4/8/2013 13:45'!
validCurrentVersion: version

	version isNil ifTrue: [ ^false ].
	(version respondsTo: #versionStatus) 
		ifTrue: [ "Use #respondsTo: until 1.0-beta.23 is in general use"
			^#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: version versionStatus ].
	^true! !

!GTMetaceller methodsFor: 'building' stamp: 'DiegoLont 9/14/2013 16:50'!
versionBrowserOn: aBrowser
	aBrowser list
		title: 'Versions';
		display: [ :config | config mainVersions ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		tags: [ :version | version tags ];
		format: [ :version | version textLabel ].
	aBrowser list 
		title: 'Methods';
		display: [ :config | config mainMethods ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		format: [ :method | method selector ].
	aBrowser tree 
		title: 'Platforms';
		display: [ :config | config projects ];
		children: [ :project | project versions ];
		updateOn: GTConfigChanged from: self announcer;
		dynamicActionsOnSelection: [ :list | list selection actions ];
		tags: [ :version | version tags ];
		format: [ :version | version textLabel ].! !

!GTMetaceller methodsFor: 'display' stamp: 'DiegoLont 4/9/2013 14:11'!
versionSourceFor: aVersion
	^aVersion asString! !

!GTMetaceller methodsFor: 'roassal' stamp: 'TudorGirba 12/8/2013 21:45'!
viewDependenciesOf: version on: view
	"| view |
	view := ROMondrianViewBuilder new.
	self new viewDependenciesOf: (ConfigurationOfMoose project version: #development) on: view.
	view open"
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires
			collect: [:each | all at: each ifAbsent: [ nil ] ] 
			thenSelect: [ :each | each notNil ] ].
	view horizontalDominanceTreeLayout layered! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller2
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

!GTMetaceller2 commentStamp: 'DiegoLont 3/14/2014 14:52' prior: 0!
GTMetaceller is a tool for browsing configurations. For more information see helpText!

!GTMetaceller2 methodsFor: 'announcements' stamp: 'DiegoLont 3/18/2014 11:34'!
announce: anAnnouncement
	self halt.
	self announcer announce: anAnnouncement! !

!GTMetaceller2 methodsFor: 'announcements' stamp: 'DiegoLont 3/14/2014 11:56'!
announcer
	^ announcer ifNil: [ announcer := GTMetacellerModel default announcer ]! !

!GTMetaceller2 methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 10:19'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'New Metaceller'.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help';
		initialExtent: self initialExtent.
	browser
		row: #configs;
		row: #configButtons size: 30.
	browser transmit
		to: #configs;
		andShow: [ :a | self configurationsIn: a ].
	browser transmit
		to: #configButtons;
		andShow: [ :a | self startConfigActionsIn: a ].
	browser transmit
		from: #configs;
		to: #configButtons;
		andShow: [ :a | self configActionsIn: a ].
	^ browser! !

!GTMetaceller2 methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 09:55'!
childrenForItem: anItem
	anItem isString ifTrue: [ ^#() ].
	^anItem children! !

!GTMetaceller2 methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:01'!
configActionsIn: a
	^ a actionList
			act: [ :entity | self newConfiguration ] entitled: 'New...';
			act: [ :entity :selected | self openConfiguration: selected ] entitled: 'Analyze';
			act: [ :entity :selected | self installConfiguration: selected ] entitled: 'Install';
			yourself! !

!GTMetaceller2 methodsFor: 'building' stamp: 'DiegoLont 3/17/2014 11:50'!
configurationsIn: a
	^ a list
		title: 'Configurations';
		display: #configurations;
		format: [ :configuration | configuration shortName ];
		updateOn: GTConfigLoaded from: self announcer;
		populate: #acceptedCode icon: GLMUIThemeExtraIcons glamorousRefresh on: $r entitled: 'Refresh' with: [ :pane | self announce: GTConfigLoaded ];
		selectionAct: [ :list | list selection browse ] entitled: 'Browse implementation';
		selectionAct: [ :list | list selection mainProject inspect ] entitled: 'Inspect'! !

!GTMetaceller2 methodsFor: 'opening' stamp: 'DiegoLont 3/14/2014 11:54'!
entity 
	^ GTMetacellerModel default! !

!GTMetaceller2 methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 12:09'!
helpText
	^'Metaceller is a tool for browsing and editing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Selecting a configuration causes it to display information about it. The color of the version give information about the blessing:
- bold = a release version
- blue = a development version
- red  = a baseline

For most configurations the stable version should be a release and a development version should be blessed with "development".

Most common actions are listed with a version. Not that the default group is "default", the default version is "#stable".
- Validate: performs a test of the version and configurations used that are loaded in image.
- Test: performs a test of the version and configurations used. Note that this installs used configurations.
- Install: Installs the selected version and group.
- Open: Opens the configuration for more details and possibilities.

.....

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- bold = the stable version
- blue = the development version
- red  = the current bleeding edge
The tag shows the blessing of the configuration.

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = project
- bold = newer package in version than loaded in image
- underlined = package / project loaded in image
- italic = groups
- gray = older package in version than loaded in image
.'! !

!GTMetaceller2 methodsFor: 'building' stamp: 'DiegoLont 3/14/2014 16:05'!
initialExtent
	| maxSize retVal |
	maxSize := RealEstateAgent maximumUsableArea extent - (RealEstateAgent scrollBarSetback @ RealEstateAgent screenTopSetback).
	retVal := RealEstateAgent standardWindowExtent.
	(self prefHeight < maxSize y )
		ifTrue: [ ^RealEstateAgent standardWindowExtent x@self prefHeight ]
		ifFalse: [ ^RealEstateAgent standardWindowExtent x@maxSize y ]	! !

!GTMetaceller2 methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 10:20'!
installConfiguration: aConfig 
	aConfig installDialog! !

!GTMetaceller2 methodsFor: 'actions' stamp: 'DiegoLont 3/14/2014 16:27'!
newConfiguration
	" todo: add a wizard to add a configuration "! !

!GTMetaceller2 methodsFor: 'actions' stamp: 'DiegoLont 3/17/2014 13:23'!
openConfiguration: aConfig 
	aConfig openMetacellerDetails! !

!GTMetaceller2 methodsFor: 'building' stamp: 'DiegoLont 3/17/2014 11:48'!
prefHeight
	^900! !

!GTMetaceller2 methodsFor: 'building' stamp: 'DiegoLont 3/17/2014 13:13'!
startConfigActionsIn: a
	^ a actionList
			act: [ :entity | self newConfiguration ] entitled: 'New...';
			yourself! !

GLMGlobalBrowserTemplate subclass: #GTMetacellerBrowserTemplate
	instanceVariableNames: 'announcer configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

GTMetacellerBrowserTemplate subclass: #GTMetacellerAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

!GTMetacellerAnalyzer methodsFor: 'building' stamp: 'DiegoLont 3/19/2014 11:26'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Analyze ', self configuration configName.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller analyze help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		row: [ :r | r
			column: #versions;
			column: #groups ];
		row: #details;
		row: #buttons size: 30.
	browser transmit
		to: #versions;
		andShow: [ :a | self versionsIn: a ].
	browser transmit
		to: #groups;
		andShow: [ :a | self groupsIn: a ].
	browser transmit
		to: #details;
		andShow: [ :a | self details: a ].
	browser transmit
		from: #versions;
		to: #details;
		andShow: [ :a | self details: a ].
	browser transmit
		from: #groups;
		to: #details;
		andShow: [ :a | self details: a ].
	browser transmit
		to: #buttons;
		andShow: [ :a | self buttonsIn: a ].
	browser transmit
		from: #versions; from: #groups;
		to: #buttons;
		andShow: [ :a | self buttonsForVersionsAndGroups: a ].
	^ browser! !

!GTMetacellerAnalyzer methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 11:59'!
buttonsForVersionsAndGroups: aBrowser
	aBrowser actionList
		act: [ :entity :version :groups | self validateVersion: version groups: groups ] entitled: 'Validate';
		act: [ :entity :version :groups | self testVersion: version groups: groups ] entitled: 'Test';
		allowNil;
		yourself.
	aBrowser actionList
		act: [ :entity :version :groups | self validateVersion: version groups: groups ] entitled: 'Validate';
		act: [ :entity :version :groups | self testVersion: version groups: groups ] entitled: 'Test';
		allowAllNil;
		yourself	! !

!GTMetacellerAnalyzer methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:00'!
buttonsIn: aBrowser
	aBrowser actionList
		act: [ :entity | self validateConfiguration ] entitled: 'Validate';
		act: [ :entity | self testConfiguration ] entitled: 'Test';
		yourself! !

!GTMetacellerAnalyzer methodsFor: 'accessing' stamp: 'DiegoLont 3/19/2014 10:25'!
helpText
	^'Todo'! !

!GTMetacellerAnalyzer methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 11:59'!
testConfiguration
	self configuration test.
	GTMetacellerModel announce: (GTConfigChanged on: self configuration)! !

!GTMetacellerAnalyzer methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 11:59'!
testItems: aGroupList
	self configuration testItems: aGroupList.
	GTMetacellerModel announce: (GTConfigChanged on: self configuration)! !

!GTMetacellerAnalyzer methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 11:59'!
testVersion: aVersion groups: aGroupList
	aVersion ifNil: [ ^self testItems: aGroupList ].
	aVersion test: aGroupList.
	GTMetacellerModel announce: (GTConfigChanged on: self configuration)! !

!GTMetacellerAnalyzer methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 11:59'!
validateConfiguration
	self configuration validate.
	GTMetacellerModel announce: (GTConfigChanged on: self configuration)! !

!GTMetacellerAnalyzer methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 11:59'!
validateItems: aGroupList
	self configuration validateItems: aGroupList.
	GTMetacellerModel announce: (GTConfigChanged on: self configuration)! !

!GTMetacellerAnalyzer methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 11:59'!
validateVersion: aVersion groups: aGroupList
	aVersion ifNil: [ ^self validateItems: aGroupList ].
	aVersion validate: aGroupList.
	GTMetacellerModel announce: (GTConfigChanged on: self configuration)! !

!GTMetacellerBrowserTemplate methodsFor: 'events' stamp: 'DiegoLont 3/18/2014 12:10'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!GTMetacellerBrowserTemplate methodsFor: 'events' stamp: 'DiegoLont 3/18/2014 12:10'!
announcer
	^announcer ifNil: [ announcer := Announcer new ]! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:10'!
buttonsForVersionsAndGroups: aBrowser
	aBrowser actionList
		act: [ :entity :version :groups | self installVersion: version groups: groups ] entitled: 'Install';
		allowNil;
		yourself.
	aBrowser actionList
		act: [ :entity :version :groups | self installVersion: version groups: groups ] entitled: 'Install';
		allowAllNil;
		yourself	! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:10'!
buttonsIn: aBrowser
	aBrowser actionList
		act: [ :entity | self install ] entitled: 'Install';
		yourself	! !

!GTMetacellerBrowserTemplate methodsFor: 'selection' stamp: 'DiegoLont 3/18/2014 12:10'!
childrenForItem: anItem
	anItem isString ifTrue: [ ^#() ].
	^anItem children! !

!GTMetacellerBrowserTemplate methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 12:10'!
configuration
	^configuration! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:16'!
details: aBrowser
	aBrowser text
		title: 'Details';
		format: [ :item | self detailsForItem: item ];
		updateOn: GTConfigChanged from: self announcer;
		yourself
		! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:19'!
detailsForItem: anItem
	anItem ifNil: [ ^self configuration infoText ].
	anItem isCollection ifTrue: [
		anItem ifEmpty: [ ^self configuration infoText ].
		^anItem inject: Text new into: [ :retVal :each | retVal append: each infoText; append: String cr; yourself ] ].
	^anItem infoText! !

!GTMetacellerBrowserTemplate methodsFor: 'opening' stamp: 'DiegoLont 3/18/2014 12:10'!
entity
	^self configuration! !

!GTMetacellerBrowserTemplate methodsFor: 'selection' stamp: 'DiegoLont 3/18/2014 12:10'!
groupsFor: aConfigOrVersion
	aConfigOrVersion ifNil: [ ^self configuration groups ].
	^aConfigOrVersion groups! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:10'!
groupsIn: aBrowser
	aBrowser list
		title: 'Groups';
		display: [ :configOrVersion | self groupsFor: configOrVersion ];
		format: #labelAsText;
		updateOn: GTConfigChanged from: self announcer;
		allowDeselection;
		allowNil;
		beMultiple;
		yourself.
	aBrowser tree
		title: 'Packages';
		display: [ :configOrVersion | self packagesAndGroupsFor: configOrVersion ];
		children: [ :item | self childrenForItem: item ];
		format: #labelAsText;
		updateOn: GTConfigChanged from: self announcer;
		allowDeselection;
		allowNil;
		beMultiple;
		yourself

		! !

!GTMetacellerBrowserTemplate methodsFor: 'initialization' stamp: 'DiegoLont 3/18/2014 12:10'!
initialize
	super initialize.
	self register! !

!GTMetacellerBrowserTemplate methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 12:10'!
install
	self install: nil! !

!GTMetacellerBrowserTemplate methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 12:10'!
install: aGroups
	self configuration install: aGroups! !

!GTMetacellerBrowserTemplate methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 12:10'!
installVersion: aVersion groups: aGroups
	aVersion ifNil: [ ^self install: aGroups ].
	aVersion install: aGroups! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:10'!
openOn: aConfiguration
	configuration := aConfiguration.
	super openOn: aConfiguration! !

!GTMetacellerBrowserTemplate methodsFor: 'selection' stamp: 'DiegoLont 3/18/2014 12:10'!
packagesAndGroupsFor: aConfigOrVersion
	aConfigOrVersion ifNil: [ ^self configuration groupsAndLoosePackages ].
	^aConfigOrVersion groupsAndLoosePackages! !

!GTMetacellerBrowserTemplate methodsFor: 'events' stamp: 'DiegoLont 3/18/2014 12:10'!
register
	GTMetacellerModel default announcer weak
		on: GTConfigChanged send: #updateConfig: to: self! !

!GTMetacellerBrowserTemplate methodsFor: 'events' stamp: 'DiegoLont 3/18/2014 12:10'!
updateConfig: anAnnouncement
	anAnnouncement config = self configuration ifTrue: [ self announce: anAnnouncement ]! !

!GTMetacellerBrowserTemplate methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:10'!
versionsIn: aBrowser
	aBrowser list
		title: 'Versions';
		display: [ :config | config basicVersions ];
		format: #labelAsText;
		updateOn: GTConfigChanged from: self announcer;
		allowDeselection;
		yourself.
	aBrowser list
		title: 'All versions';
		display: [ :config | config mainVersions ];
		format: #labelAsText;
		updateOn: GTConfigChanged from: self announcer;
		allowDeselection;
		yourself.
! !

GTMetacellerBrowserTemplate subclass: #GTMetacellerInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

!GTMetacellerInstaller methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 12:17'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Install ', self configuration configName.
	browser
		act: [ :b | 
			Workspace new
				contents: self helpText;
				openLabel: 'Metaceller install help' ]
		icon: GLMUIThemeExtraIcons glamorousHelp
		entitled: 'Help'.
	browser
		row: [ :r | r
			column: #versions;
			column: #groups ];
		row: #details;
		row: #buttons size: 30.
	browser transmit
		to: #versions;
		andShow: [ :a | self versionsIn: a ].
	browser transmit
		to: #groups;
		andShow: [ :a | self groupsIn: a ].
	browser transmit
		from: #versions;
		to: #details;
		andShow: [ :a | self details: a ].
	browser transmit
		from: #groups;
		to: #details;
		andShow: [ :a | self details: a ].
	browser transmit
		to: #details;
		andShow: [ :a | self details: a ].
	browser transmit
		to: #buttons;
		andShow: [ :a | self buttonsIn: a ].
	browser transmit
		from: #versions; from: #groups;
		to: #buttons;
		andShow: [ :a | self buttonsForVersionsAndGroups: a ].
	^ browser! !

!GTMetacellerInstaller methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 10:45'!
buttonsForVersionsAndGroups: aBrowser
	aBrowser actionList
		act: [ :entity :version :groups | self installVersion: version groups: groups ] entitled: 'Install';
		allowNil;
		yourself.
	aBrowser actionList
		act: [ :entity :version :groups | self installVersion: version groups: groups ] entitled: 'Install';
		allowAllNil;
		yourself	! !

!GTMetacellerInstaller methodsFor: 'building' stamp: 'DiegoLont 3/18/2014 10:31'!
buttonsIn: aBrowser
	aBrowser actionList
		act: [ :entity | self install ] entitled: 'Install';
		yourself	! !

!GTMetacellerInstaller methodsFor: 'accessing' stamp: 'DiegoLont 3/19/2014 10:29'!
helpText
	^'The metaceller installer is a graphical ui to install an existing configuration.
You can select a version and from this version one or more groups.
If no version is selected the following version ordering is used to determine a default version: stable, development, bleedingedge.
If no group is selected the "default" group is used (see Metacello documentation).
If installation fails, please use the Metaceller analyzer to determine the problem.'! !

!GTMetacellerInstaller methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 10:48'!
install
	self install: nil! !

!GTMetacellerInstaller methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 10:48'!
install: aGroups
	self configuration install: aGroups! !

!GTMetacellerInstaller methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 10:48'!
installVersion: aVersion groups: aGroups
	aVersion ifNil: [ ^self install: aGroups ].
	aVersion install: aGroups! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ self projectReference version spec packages packageSpecsInLoadOrder! !

!MetacelloProjectReferenceSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:12'!
labelAsText	
	^ self name, ' ', self versionString! !

!MetacelloSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:17'!
children 
	^ #()! !

!MetacelloSpec methodsFor: '*gt-metaceller-glamour' stamp: 'TudorGirba 4/1/2013 09:14'!
labelAsText	
	^ self label! !

!GTMetacellerConfiguration methodsFor: '*gt-metaceller-glamour' stamp: 'DiegoLont 3/18/2014 09:42'!
infoText
	| retVal |
	retVal := Text new.
	retVal append: 'Name: ', self shortName; append: String cr.
	retVal append: (Text string: 'Stable: ' attribute: TextEmphasis bold).
	self stableVersion
		ifNil: [ retVal append: '-' ]
		ifNotNilDo: [ :ver | retVal append: ver asText ].
	retVal append: String cr.
	retVal append: (Text string: 'Development: ' attribute: TextColor blue).
	self developmentVersion
		ifNil: [ retVal append: '-' ]
		ifNotNilDo: [ :ver | retVal append: ver asText ].
	retVal append: String cr.
	retVal append: (Text string: 'Bleeding edge: ' attribute: TextColor red).
	self bleedingEdgeVersion
		ifNil: [ retVal append: '-' ]
		ifNotNilDo: [ :ver | retVal append: ver asText ].
	retVal append: String cr.
	^retVal! !

!GTMetacellerConfiguration methodsFor: '*gt-metaceller-glamour' stamp: 'DiegoLont 3/18/2014 10:39'!
installDialog
	^GTMetacellerInstaller openOn: self! !

!GTMetacellerConfiguration methodsFor: '*gt-metaceller-glamour' stamp: 'DiegoLont 3/18/2014 12:01'!
openMetacellerDetails
	^GTMetacellerAnalyzer openOn: self! !

GTMetacellerConfiguration subclass: #GTRefreshableMetacellerConfiguration
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Glamour'!

!GTRefreshableMetacellerConfiguration class methodsFor: 'instance creation' stamp: 'DiegoLont 10/8/2013 10:48'!
on: aConfiguration announcer: anAnnouncer
	^(self on: aConfiguration)
		announcer: anAnnouncer;
		yourself! !

!GTRefreshableMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 10/8/2013 10:48'!
announcer
	^ announcer! !

!GTRefreshableMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 10/8/2013 10:49'!
announcer: anObject
	self unregister.
	announcer := anObject.
	self register! !

!GTRefreshableMetacellerConfiguration methodsFor: 'refresh' stamp: 'DiegoLont 10/8/2013 10:50'!
register
	self announcer ifNotNil: [ self announcer on: GTConfigChanged do: [ :ann | self updateChange: ann ] ]! !

!GTRefreshableMetacellerConfiguration methodsFor: 'refresh' stamp: 'DiegoLont 10/8/2013 10:51'!
unregister
	self announcer ifNotNil: [ self announcer removeSubscriber: self ]! !

!GTRefreshableMetacellerConfiguration methodsFor: 'refresh' stamp: 'DiegoLont 10/8/2013 10:53'!
updateChange: ann
	self reset! !
